Educational Codeforces Round 39 (Rated for Div. 2) D. Timetable(动态规划)

D. Timetable
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Ivan is a student at Berland State University (BSU). There are n days in Berland week, and each of these days Ivan might have some classes at the university.

There are m working hours during each Berland day, and each lesson at the university lasts exactly one hour. If at some day Ivan’s first lesson is during i-th hour, and last lesson is during j-th hour, then he spends j - i + 1 hours in the university during this day. If there are no lessons during some day, then Ivan stays at home and therefore spends 0 hours in the university.

Ivan doesn’t like to spend a lot of time in the university, so he has decided to skip some lessons. He cannot skip more than k lessons during the week. After deciding which lessons he should skip and which he should attend, every day Ivan will enter the university right before the start of the first lesson he does not skip, and leave it after the end of the last lesson he decides to attend. If Ivan skips all lessons during some day, he doesn’t go to the university that day at all.

Given n, m, k and Ivan’s timetable, can you determine the minimum number of hours he has to spend in the university during one week, if he cannot skip more than k lessons?
Input

The first line contains three integers n, m and k (1 ≤ n, m ≤ 500, 0 ≤ k ≤ 500) — the number of days in the Berland week, the number of working hours during each day, and the number of lessons Ivan can skip, respectively.

Then n lines follow, i-th line containing a binary string of m characters. If j-th character in i-th line is 1, then Ivan has a lesson on i-th day during j-th hour (if it is 0, there is no such lesson).
Output

Print the minimum number of hours Ivan has to spend in the university during the week if he skips not more than k lessons.
Examples
Input
Copy

2 5 1
01001
10110

Output

5

Input
Copy

2 5 0
01001
10110

Output

8

Note

In the first example Ivan can skip any of two lessons during the first day, so he spends 1 hour during the first day and 4 hours during the second day.

In the second example Ivan can’t skip any lessons, so he spends 4 hours every day.

题解:bet[i][j]表示第i天旷j节课可以在家呆多长时间,这个可以暴力求出.
然后dp[i][j]表示前i天旷j节课可以在家呆多长时间,三重循环就得出正确结果了

#include<bits/stdc++.h>
#define ll long long
#define inf 0x3f3f3f3f
#define pb push_back
#define rep(i,a,b) for(int i=a;i<b;i++)
#define rep1(i,b,a) for(int i=b;i>=a;i--)
using namespace std;
const int N=510;
char a[N][N];
int  sum[N][N];
int  bet[N][N], dp[N][N];
int main()
{
    int i, j, k, n, m, V, temp, ans;
    cin>>n>>m>>V;
    for(i=1;i<=n;i++)
    {
        for(j=1;j<=m;j++)
        {
            cin>>a[i][j];
            if(a[i][j]=='1')
                sum[i][j] = sum[i][j-1]+1;
            else
                sum[i][j] = sum[i][j-1];
        }
    }
    for(i=1;i<=n;i++)
    {
        for(j=1;j<=m;j++)
        {
            for(k=j-1;k<=m;k++)//考虑一节课也不上
            {
                temp = sum[i][m]-(sum[i][k]-sum[i][j-1]);
                bet[i][temp] = max(bet[i][temp], m-(k-j+1));
            }
        }
    }
    for(i=1;i<=n;i++)
    {
        for(j=0;j<=V;j++)
        {
            for(k=0;k<=j;k++)
                dp[i][j] = max(dp[i][j], dp[i-1][k]+bet[i][j-k]);
                //前i-1天旷k节加上这一天旷j-k节
        }
    }
    cout<<n*m-dp[n][V]<<endl;
    return 0;
}
posted @ 2018-03-10 17:14  ffgcc  阅读(171)  评论(0编辑  收藏  举报